VERSION 5.00
Begin VB.Form Form1 
   AutoRedraw      =   -1  'True
   BackColor       =   &H00000000&
   Caption         =   "Form1"
   ClientHeight    =   4035
   ClientLeft      =   60
   ClientTop       =   300
   ClientWidth     =   5130
   ForeColor       =   &H000000FF&
   LinkTopic       =   "Form1"
   ScaleHeight     =   269
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   342
   StartUpPosition =   3  'Windows-Standard
   Begin VB.Timer timMain 
      Enabled         =   0   'False
      Interval        =   1
      Left            =   240
      Top             =   240
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Dim Particle(1000) As Particle
Const Pi As Double = 3.14159265359

Private Declare Function GetPixel Lib "gdi32" (ByVal hdc As Long, ByVal X As Long, ByVal Y As Long) As Long
Private Declare Function SetPixel Lib "gdi32" (ByVal hdc As Long, ByVal X As Long, ByVal Y As Long, ByVal crColor As Long) As Long

Private Type Particle
    XPos As Single
    YPos As Single
    XMove As Single
    YMove As Single
    Life As Integer
    LifeDes As Byte
End Type

Private Sub Form_Load()
    Randomize Timer
End Sub

Private Sub Form_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    For i = 0 To UBound(Particle)
      With Particle(i)
        .XPos = X
        .YPos = Y
        .Life = 600 + Rnd * 200
        .XMove = Sin(Rnd * Pi * 2) * Rnd * 10
        .YMove = Cos(Rnd * Pi * 2) * Rnd * 10
        .LifeDes = 1 + Rnd * 2
      End With
    Next i
    timMain.Enabled = True
End Sub

Private Sub timMain_Timer()
    Dim Alive As Boolean
    Me.Cls
    For i = 0 To UBound(Particle)
      If Not Particle(i).Life <= 9 Then
        With Particle(i)
          .XPos = .XPos + .XMove
          .YPos = .YPos + .YMove
          If .YPos >= Me.ScaleHeight Then
            .YMove = -Abs(.YMove) * 0.4
          Else
            .YMove = .YMove + Rnd / 8
          End If
          If .XPos <= 0 Then
            .XMove = Abs(.XMove) * 0.9
          ElseIf .XPos >= Me.ScaleWidth Then
            .XMove = -Abs(.XMove) * 0.9
          End If
          .Life = .Life - .LifeDes
          SetPixel Me.hdc, .XPos, .YPos, RGB(.Life / 2, 0, 0)
        End With
        Alive = True
      End If
    Next i
    If Alive = False Then timMain.Enabled = False
End Sub
